;--------------------------------------------------------------------------
; Count motor freq/min and indicate it in decimal.
; Timer0 version by Slayer.
;--------------------------------------------------------------------------
F_WORK  BIT     001h
P4      DATA    0E8h
P5      DATA    0F8h
IEN0    DATA    0A8h
IEN1    DATA    0B8h
IP0     DATA    0A9h
IP1     DATA    0B9h
NO_INT  EQU     000h
EN_INT  EQU     08Bh ;TIM0,TIM1,KBD
T2CON   DATA    0C8h
TL2     DATA    0CCh
TH2     DATA    0CDh
CRCL    DATA    0CAh
CRCH    DATA    0CBh
CCL1    DATA    0C2h
CCH1    DATA    0C3h
CCEN    DATA    0C1h

;--------------------------------------------------------------------------
        org  0000h
        ljmp BEGIN
        org  0003h
        ljmp KEYBOARD
        org  000Bh
        inc  50h
        reti
        org  001Bh
        ljmp TIM1

BEGIN:
        clr   F_WORK
; Here we define frequency...
        mov   CCH1, #0EFh
        mov   CCL1, #000h

        mov   CRCH, #000h
        mov   CRCL, #000h
; ---------------------------

        mov   CCEN, #08h
        mov   T2CON, #31h


        mov  R1, #00h
        mov  SP, #60h
        mov  46h, #00h
        mov  47h, #00h
        mov  48h, #00h
        mov  49h, #00h
        mov  50h, #00h

        mov  IEN0, #EN_INT
        mov  IP0, #08h
        mov  IP1, #08h
        mov  TMOD, #16h
        mov  TL0, #0E8h
        mov  TH0, #0E8h
        mov  TL1, #0F0h          ; D8F0h = 55536 = 10ms
        mov  TH1, #0D8h
        mov  DPTR, #FONT
        mov  TCON, #50h

IND:
        jnb  F_WORK,SK
        jnb  P1.1,X
        clr  P3.5
        sjmp SK
X:      setb P3.5
SK:

        mov  R4, #0FEh
        mov  R0, #46h
NXT:    mov  A, @R0
        mov  P4, #0FFh
        movc A, @A+DPTR
        mov  P5, A
        mov  A, R4
        mov  P4, A
        rl   A
        mov  R4, A
        inc  R0
        mov  R5, #10
ST_2:   mov  R2, #20
ST_1:   djnz R2, ST_1
        djnz R5, ST_2
        cjne R0, #4Ah, NXT
        ljmp IND

KEYBOARD:
        push ACC
        push P4
        push PSW
        setb PSW.4      ;bank2
        clr  PSW.3
        mov  R4, #00h
        mov  R7, #04h
        mov  R6, #0feh
LOOP:   mov  A, R6
        mov  P4, A
        rl   A
        mov  R6, A
        mov  A, P4
        mov  R5, #04h
        swap A
ROTATE: rrc  A
        jnc  DBNC
        inc  R4
        djnz R5, ROTATE
        djnz R7, LOOP
        ljmp QUITKB
DBNC:   mov  R2, #0Ah
M1:     mov  R3, #55h
M2:     djnz R3, M2
        djnz R2, M1
        mov  A, #0F0h
WAIT:   mov  P4, #0F0h
        cjne A, P4, WAIT
        mov  R2, #0Ah
M3:     mov  R3, #55h
M4:     djnz R3, M4
        djnz R2, M3
        mov  A, #09h
        subb A, R4
        jc   FUNC
        mov  49h, 48h
        mov  48h, 47h
        mov  47h, 46h
        mov  46h, R4
        ljmp QUITKB
FUNC:   cjne R4, #0Ah, F2
        setb F_WORK
;        clr  P3.5
        sjmp QUITKB
F2:     clr  F_WORK
;        setb P3.5
QUITKB: pop  PSW
        pop  P4
        pop  ACC
        reti

TIM1:
        push PSW
        push ACC
        mov  IEN0, #NO_INT
        inc  R1
        cjne R1, #100, EX_TIM1      ;1sec=10ms*100
        mov  R1, #00h
        mov  A, 50h
;        mov  B, #3Ch
;        mul  AB

        mov  46h, #00h
        mov  47h, #00h
        mov  48h, #00h
        mov  49h, #00h

        setb PSW.3              ;bank1
        clr  PSW.4
        mov  R0, #46h
        mov  R2, B
        mov  R3, A
        mov  A, R2
K1:
        mov  B, #10
        div  AB
        mov  35h, A
        mov  A, R3
        anl  A, #0F0h
        swap A
        mov  R4, A
        mov  A, B
        swap A
        add  A, R4
        mov  B, #10
        div  AB
        mov  36h, A
        mov  A, R3
        anl  A, #0Fh
        mov  R4, A
        mov  A, B
        swap A
        orl  A, R4
        mov  B, #10
        div  AB
        mov  37h, A
        mov  @R0, B
        inc  R0
        mov  A, 36h
        swap A
        orl  A, 37h
        mov  R3, A
        mov  A, 35h
        mov  R2, A
        jnz  K1
        mov  A, R3
        mov  B, #10
        div  AB
        mov  @R0, B
        inc  R0
        mov  R4, A
        mov  B, #10
        div  AB
        jnz  K2
        mov  A, R4
        mov  @R0, A
        sjmp K3
K2:
        mov  @R0, A
        inc  R0
        mov  @R0, A
K3:
        mov  50h, #00h
EX_TIM1:
        mov  IEN0, #EN_INT
        pop  ACC
        pop  PSW
        mov  TL1, #0F0h
        mov  TH1, #0D8h
        reti

FONT:db 0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H,80H,90H,88H,83H,0C6H,0A1H,86H,8Eh

QUIT:
        END